<template>
	<a-drawer
		:title="formData.id ? '编辑出入库' : '增加出入库'"
		:width="600"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="企业客户：" name="depotId" v-if="!formData.depotId">
				<a-select v-model:value="formData.depotId" placeholder="请选择企业客户" :options="depotIdOptions"/>
			</a-form-item>
			<a-form-item label="出入库：" name="depotBizType">
				<a-radio-group v-model:value="formData.depotBizType" placeholder="请选择出入库" :options="depotBizTypeOptions"/>
			</a-form-item>
			<a-form-item label="负责人身份证号：" name="keeperCitizenId">
				<a-input v-model:value="formData.keeperCitizenId" placeholder="请输入负责人身份证号" allow-clear/>
			</a-form-item>
			<a-form-item label="粮食种类：" name="grainGroup">
				<a-select v-model:value="formData.grainGroup" placeholder="请输入粮食种类" :options="grainGroupOptions"/>
			</a-form-item>
			<a-form-item label="数量（吨）：" name="depotTonCount">
				<a-input v-model:value="formData.depotTonCount" placeholder="请输入数量（吨）" allow-clear/>
			</a-form-item>
			<a-form-item label="价格：" name="depotPrice">
				<a-input v-model:value="formData.depotPrice" placeholder="请输入价格" allow-clear/>
			</a-form-item>
			<a-form-item label="质量：" name="depotQuality">
				<a-input v-model:value="formData.depotQuality" placeholder="请输入质量" allow-clear/>
			</a-form-item>
			<a-form-item label="车牌：" name="licensePlate">
				<a-input v-model:value="formData.licensePlate" placeholder="请输入车牌" allow-clear/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotWorkForm">
import tool from '@/utils/tool'
import {cloneDeep} from 'lodash-es'
import {required} from '@/utils/formRules'
import depotWorkApi from '@/api/biz/depotWorkApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)
const depotIdOptions = ref([])
const depotBizTypeOptions = ref([])
const grainGroupOptions = ref([])

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	} else {
		dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
			depotIdOptions.value = data
		})
	}
	depotBizTypeOptions.value = tool.dictList('出入库')
	grainGroupOptions.value = tool.dictList('粮食种类')
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {
	depotId: [required('请输入项目编码')],
	depotBizType: [required('请输入出入库')],
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			depotWorkApi
				.depotWorkSubmitForm(formDataParam, !formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
